;;;; tinyclos-primitive-objects.scm

(module tinyclos-primitive-objects

  (;export
    add-primitive-class-of delete-primitive-class-of
    add-structure-class-of delete-structure-class-of
    add-extended-procedure-class-of delete-extended-procedure-class-of
    add-tagged-pointer-class-of delete-tagged-pointer-class-of)

  (import
    scheme
    chicken
    foreign
    (only lolevel procedure-data)
    (only tinyclos
      class?
      register-primitive-class-of
      <procedure>
      <immediate> <void> <null> <end-of-file> <boolean> <char>
      <number> <integer> <exact> <inexact>
      <symbol> <sequence> <vector> <pair> <string>
      <port> <input-port> <output-port>
      <blob> <structure> <environment> <hash-table>
      <promise> <queue> <condition> <condition-variable>
      <continuation> <char-set> <time> <lock> <mmap> <array>
      <tcp-listener> <thread> <mutex> <regexp> <read-table>
      <locative> <pointer> <swig-pointer> <tagged-pointer>
      <u8vector> <u16vector> <u32vector>
      <s8vector> <s16vector> <s32vector>
      <f32vector> <f64vector>))

  (require-library lolevel tinyclos)

(include "tinyclos-inlines")

(incude "tinyclos-primitive-objects-body")

) ;module tinyclos-primitive-objects
